<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE manualpage SYSTEM "./style/manualpage.dtd">
<?xml-stylesheet type="text/xsl" href="./style/manual.fr.xsl"?>
<!-- English Revision: 1729281 -->
<!-- French translation : Lucien GENTIS -->
<!-- Reviewed by : Vincent Deffontaines -->

<!--
 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to You under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<manualpage metafile="upgrading.xml.meta">

<title>Mise à jour vers 2.2 depuis 2.0</title>

<summary>
  <p>Afin d'assister les utilisateurs lors de leurs opérations de mise à
  jour, nous maintenons un document
  qui comporte des informations critiques à l'attention des personnes qui
  utilisent déjà Apache. Ces informations ne sont que de brèves notes, et vous
  devriez trouver plus d'informations dans le document <a
  href="new_features_2_2.html">Nouvelles fonctionnalités</a>, ou dans
  le fichier <code>src/CHANGES</code>.</p>

  <p>Ce document ne décrit que les modifications intervenues entre les versions
  2.0 et 2.2. Si vous effectuez une mise à jour depuis la version 1.3, vous
  devez aussi consulter le
  <a href="http://httpd.apache.org/docs/2.0/upgrading.html">document de mise
  à jour de 1.3 vers 2.0.</a></p>

</summary>
<seealso><a href="new_features_2_2.html">Vue d'ensemble des nouvelles
fonctionnalités de Apache 2.2</a></seealso>

  <section id="compile-time">
    <title>Modifications de la configuration au moment de la compilation</title>

    <p>Le processus de compilation est très similaire à celui de la
    version 2.0. Dans certains cas, vous pourrez même utiliser
    votre ancienne ligne de commande
    <code>configure</code> (que vous trouverez dans le fichier
    <code>build/config.nice</code> à la racine du répertoire des sources de
    votre serveur). Les changements qui devront être le plus souvent effectués
    concerneront des noms de modules, et en particulier les modules gérant
    l'authentification et les autorisations.
    Quelques exemples de modifications :</p>

    <ul>
      <li>mod_imap a été renommé en <module>mod_imagemap</module></li>
      <li>mod_auth a été scindé en quatre modules :
      <module>mod_auth_basic</module>,
          <module>mod_authn_file</module>, <module>mod_authz_user</module>, et
          <module>mod_authz_groupfile</module></li>
      <li>mod_access a été renommé en <module>mod_authz_host</module></li>
      <li>mod_auth_ldap a été renommé en <module>mod_authnz_ldap</module></li>
      <li>La version requise pour l'API APR est la 1.0.</li>
      <li>La version de la bibliothèque PCRE intégrée est la 5.0</li>
    </ul>

  </section>

  <section id="run-time">
    <title>Modifications de la configuration à l'exécution</title>

    <p>Vos fichiers de configuration et scripts de démarrage de la version 2.0
    existante peuvent en général être utilisés sans modification avec la
    version 2.2. Quelques petits ajustements peuvent cependant être nécessaires
    dans le cas de configurations particulières comme décrit plus bas.
    En outre, si des modules standards sont chargés dynamiquement à l'aide de
    la directive <directive module="mod_so">LoadModule</directive>,
    vous devez vérifier les changements de noms de modules mentionnés
    plus haut.</p>

    <p>Si vous choisissez d'utiliser le nouveau fichier de configuration par
    défaut de la
    version 2.2, vous vous apercevrez qu'il a été considérablement simplifié
    et ne conserve que les points les plus essentiels de la configuration.
    Plusieurs exemples de configurations utilisant des fonctionnalités plus
    avancées sont disponibles dans le répertoire
      <code>conf/extra/</code> de l'installation du serveur. Les fichiers de
      configuration par défaut se trouvent dans le répertoire
      <code>conf/original</code>.</p>

    <p>Quelques changements dans la configuration à l'exécution que vous
    pouvez noter :</p>

    <ul>
      <li>L'option <code>startssl</code> du programme
      <program>apachectl</program> n'est plus disponible. Pour activer le
      support SSL, vous devez éditer <code>httpd.conf</code> de façon à
      inclure les directives du module <module>mod_ssl</module>
      correspondantes, puis utiliser la commande <code>apachectl start</code>
      pour démarrer le serveur. Vous trouverez un exemple de configuration
      permettant d'activer le module <module>mod_ssl</module> dans le fichier
      <code>conf/extra/httpd-ssl.conf</code>.</li>

      <li>La directive <directive
      module="core">UseCanonicalName</directive> est maintenant définie par
      défaut à <code>Off</code>. Si cette directive
      n'était pas présente dans votre
      ancien fichier de configuration, vous pouvez ajouter
      <code>UseCanonicalName On</code> dans le nouveau pour garder inchangé
      l'ancien comportement.</li>

      <li>Le module <module>mod_userdir</module> ne sera appliqué sur les
      requêtes que si une directive <directive
      module="mod_userdir">UserDir</directive> spécifiant un nom de répertoire
      se trouve dans le fichier de configuration. Pour garder l'ancien
      comportement par défaut inchangé, placer la directive <code>UserDir
      public_html</code> dans votre fichier de configuration.</li>

      <li>La directive <directive>AuthDigestFile</directive>
      du module <module>mod_auth_digest</module> a été fusionnée avec la
      directive <directive module="mod_authn_file">AuthUserFile</directive>
      et appartient maintenant au module <module>mod_authn_file</module>.</li>

      <li>Les directives <directive
      module="mod_rewrite">RewriteRule</directive>sont évaluées avant les
      directives <directive module="mod_proxy">ProxyPass</directive>.</li>
    </ul>
  </section>

  <section id="misc">
    <title>Changements divers</title>

    <ul>
      <li>Le module <module>mod_cache</module>, qui était
      expérimental dans Apache 2.0, est désormais un module standard.</li>

      <li>Le module <module>mod_disk_cache</module>, qui était
      expérimental dans Apache 2.0, est désormais un module standard.</li>

      <li>Le module <module>mod_mem_cache</module>, qui était
      expérimental dans Apache 2.0, est désormais un module standard.</li>

      <li>Le module <module>mod_charset_lite</module>, qui était
      expérimental dans Apache 2.0, est désormais un module standard.</li>

      <li>Le module <module>mod_dumpio</module>, qui était
      expérimental dans Apache 2.0, est désormais un module standard.</li>

    </ul>
  </section>

  <section id="third-party">
    <title>Modules tiers</title>

   <p>De nombreux modules tiers conçus pour la version 2.0 fonctionneront sans
   changement avec le serveur HTTP Apache version 2.2. Mais tous ces modules
   doivent être recompilés avant de pouvoir être chargés.</p>

  </section>
</manualpage>
